/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/23
 * Description 		    :
 *******************************************************************************/

#include "CH57x_common.h"

#include "ch57x_soft_i2c.h"

#include <stdbool.h>


void DebugInit( void )
{
  GPIOA_SetBits( GPIO_Pin_9 );
  GPIOA_ModeCfg( GPIO_Pin_8, GPIO_ModeIN_PU );
  GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );
  UART1_DefInit();
}

int main()
{
  UINT8 i;

  SetSysClock( CLK_SOURCE_PLL_60MHz );

  DebugInit();
  PRINT( "Start @ChipID=%02X\n", R8_CHIP_ID );
  PRINT("ch573/571 soft iic example\r\n");

  ch57x_soft_i2c_init();

  uint8_t buf[3] = {0};
  while(1) {
#if 1
      ch57x_soft_i2c_start();
      ch57x_soft_i2c_send_byte(0x80);
      ch57x_soft_i2c_wait_ack();
      ch57x_soft_i2c_send_byte(0xF5);
      ch57x_soft_i2c_wait_ack();
      ch57x_soft_i2c_stop();
      DelayMs(20);
      ch57x_soft_i2c_start();
      ch57x_soft_i2c_send_byte(0x81);
      ch57x_soft_i2c_wait_ack();
      buf[0] = ch57x_soft_i2c_read_byte(1);
      buf[1] = ch57x_soft_i2c_read_byte(0);
      ch57x_soft_i2c_stop();
      PRINT("RAW:%02x %02x, humidity:   %d\r\n",buf[0],buf[1],(buf[0]<<8|buf[1])*125/65536 - 6);
#endif 

      ch57x_soft_i2c_start();
      ch57x_soft_i2c_send_byte(0x80);
      ch57x_soft_i2c_wait_ack();
      ch57x_soft_i2c_send_byte(0xE0);
      ch57x_soft_i2c_wait_ack();
      ch57x_soft_i2c_start();
      ch57x_soft_i2c_send_byte(0x81);
      ch57x_soft_i2c_wait_ack();
      buf[0] = ch57x_soft_i2c_read_byte(1);
      buf[1] = ch57x_soft_i2c_read_byte(0);
      ch57x_soft_i2c_stop();
      PRINT("RAW:%02x %02x  temperature:%d\r\n",buf[0],buf[1],(buf[0]<<8|buf[1])*17572/65536 - 4685);
      DelayMs(100);

  }
}



